<script lang="ts">
	export let storageAdapter: StorageAdapter
	export let projectFilter: ProjectFilter | undefined = undefined

	import type { StorageAdapter, Project, ProjectFilter } from "$lib/storage"
	import MultilineLoadIndicator from "./MultilineLoadIndicator.svelte"

	let projectsPromise: Promise<Array<Project>>

	function reloadProjects(storageAdapter: StorageAdapter) {
		projectsPromise = storageAdapter.fetchProjects({ ...projectFilter, reload: true })
	}

	$: projectsPromise = storageAdapter.fetchProjects(projectFilter)
</script>

{#await projectsPromise}
	<MultilineLoadIndicator />
{:then projects}
	<slot {projects} />
{:catch err}
	<div class="alert text-red-700 bg-red-100 mt-4" role="alert">Could not fetch projects: {err.message}</div>
{/await}

<div class="mt-4">
	<button class="btn btn-link" on:click|preventDefault={() => reloadProjects(storageAdapter)}>reload</button>
</div>
